#ifndef STRICMP_H
#define STRICMP_H 1

#pragma CALLEE-SAVES stricmp_asm,strcpy_asm
#pragma CALLEE-SAVES strlen_asm,str_is_dot_mp3
#pragma CALLEE-SAVES memset_asm,string_init_asm

extern xdata char * data strcpy_asm_src_addr;

#define stricmp(a, b) (strcpy_asm_src_addr = (b), stricmp_asm(a))

#define memset(ptr, ch, len) \
   (strcpy_asm_src_addr = (xdata char *)(((ch) << 8) | (len)), \
   memset_asm(ptr))

#define string_init(str, ch, len) \
   (strcpy_asm_src_addr = (xdata char *)(((ch) << 8) | ((len) - 1)), \
   string_init_asm(str))

extern char stricmp_asm(xdata char *a) _naked;
extern void memset_asm(xdata void *ptr) _naked;
extern void string_init_asm(xdata char *str) _naked;
void strcpy_asm(xdata char *dest_addr);
unsigned char strlen_asm(xdata char *str);
unsigned char str_is_dot_mp3(xdata unsigned char *str);
unsigned char str_is_dot_m3u(xdata unsigned char *str);

#endif

