#include "parse.h"
#include "playlist.h"
#include "params.h"

xdata struct id3_tag_struct {
	xdata char id3[4];
	xdata char title[31];
	xdata char artist[31];
	xdata char album[31];
	xdata char year[5];
	xdata char comment[31];
	unsigned char genre_code;
	unsigned char track_number;
};

extern struct id3_tag_struct id3_tag;

void lcd_setup(void);
void lcd_user_action(event_t event);
void lcd_set_filename(simm_id filename);
void lcd_set_playlistname(simm_id filename);
void lcd_change(param_t parm);
void lcd_change_menu(unsigned char action);
void lcd_display_id3_init();
void lcd_display_id3_struct();
void lcd_screen_dynamic(const unsigned char refresh);
void lcd_set_scroll_speed();
void lcd_timer_callback();
void lcd_update_backlight_timer();

#define SCROLL_SPEED 5

